#include <bits/stdc++.h>
 
using namespace std;
 
#define speed ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define rall(x) x.rbegin(), x.rend()
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define mp make_pair
#define pb push_back
#define F first
#define S second
#define nl '\n'
// #define int long long 
 
typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef long double ld;
 
const int N = 1e6 + 5;
const int inf = 1e9+123;
const ll INF = 1e15 + 5;
const int mod = 1e9 + 7;
const int P = 31;

ll h, w, ans;

void rec(ll y, ll x){
    ans += y * x;
    // cout << y << ' ' << x << nl;
    if(y == 1 && x == 1)
        return;
    if(x < y){
        ll fir = y / 2;
        ll sec = y - fir;
        rec(fir, x);
        rec(sec, x);
    }
    else{
        ll fir = x / 2;
        ll sec = x - fir;
        rec(y, fir);
        rec(y, sec);
    }
}

void solve(){
    cin >> h >> w;
    rec(h, w);
    cout << ans << nl;
}
 
signed main() {
    speed;
    int T = 1;
    // cin >> T;
    while(T--)
        solve();
}